<template>
  <div
    ref="el"
    class="maplibregl-ctrl maplibregl-ctrl-group">
    <slot />
  </div>
</template>

<script>
// https://maplibre.org/maplibre-gl-js-docs/api/markers/#icontrol

import { propsControl } from './shared/props.js'

export const opts = Object.assign({},
  propsControl
)
</script>

<script setup>
import { ref, onMounted } from 'vue'
import { setupControl } from './shared/setup.js'
import { eventsControl } from './shared/events.js'

const el = ref(null)
const props = defineProps(opts)
const emit = defineEmits(eventsControl)

class CustomControl {
  onAdd (map) {
    this._map = map
    this._container = el.value
    return this._container
  }
  onRemove () {
    this._container.parentNode.removeChild(this._container)
    this._map = undefined
  }
}

const ctrl = ref(null)

onMounted(() => {
  const { control } = setupControl(CustomControl, props, emit)
  ctrl.value = control
})

defineExpose({ control: ctrl })
</script>
